#!/usr/bin/python
# -*- encoding: utf-8 -*-

# testovaci program pro expander s adresou 0x21 
# na GPA0 az GPA jsou LEDky
# na GPB0 a GPB1 jsou tlacitka

import smbus
import time

bus = smbus.SMBus(1) # novejsi varianta RasPi (512MB)
addr_exp = 0x21     # i2c adresa expanderu

bus.write_byte_data(addr_exp,0x00,0b00000000 ) # cely port A nastavit na vystup (LEDky)
bus.write_byte_data(addr_exp,0x01,0b11111111 ) # cely port B nastavit na vstup (tlacitka)
bus.write_byte_data(addr_exp,0x0D,0b11111111 ) # na vsechny bity portu B pripojit vnitrni Pull-Upy


tlacitka = 0b11                                # na zacatku se predpoklada, ze jsou obe tlacitka nestisknuta
while (tlacitka != 0b00):                      # program bezi tak dlouho, dokud nejsou sisknuta obe tlacitka najednou
  portb = bus.read_byte_data(addr_exp,0x13)    # cteni stavu tlacitek
  tlacitka = portb & 0b00000011                # ze stavu tlacitek jsou dulezite jen spodni 2 bity (tlacitko 1 a 2)

  porta = bus.read_byte_data(addr_exp,0x12)    # zjisteni aktualne rozsvicenych LEDek

  # rozsvecovani
  if (tlacitka == 0b10):                       # tlacitko 1 na portu GPB0 je stisknuto (stav "0")
    porta = (porta << 1) + 1                   # pri rozsvecovani se zprava pridavaji "1"
    if (porta > 0b1111): porta = 0b1111        # pri prekroceni 4 LED uz se dal nic nepridava
  
  # zhasinani
  if (tlacitka == 0b01):                       # tlacitko 2 na portu GPB1 je stisknuto (stav "0")
    porta = (porta >> 1)                       # pri zhasinani se "1" posouvaji doprava a jsou nahrazovany zleva nulami 

  bus.write_byte_data(addr_exp,0x12,porta)     # nastaveni noveho stavu portu A na expanderu

  time.sleep(0.5)                              # kratka pauza mezi zmenami stavu LED





  
    